﻿#pragma once

#include "Drawer.h"

using namespace TringineDx;

namespace Tringine
{
	namespace Entities
	{
		/*
			Класс представляющий базовый функционал всех объектов игры
		*/
		class Base
		{
		protected:
			//Активен ли объект
			bool _isActive;

			//Существует (жив) ли объект
			bool _isExists;

			//Видим ли объект
			bool _isVisible;
		public:
			//Родительский элемент объекта в графе сцены
			Base* ParentPointer;

			//Базовый конструктор
			Base();

			//Базовый деструктор
			virtual ~Base();

			/*
				Функция обновления - вызывается каждый шаг один раз
				Должна выполнять базовые обновления состояния объекта
			*/
			virtual void Update(float timeScale);

			/*
				Функция пост обновления - вызывается каждый шаг один раз после того как у всех объектов графа сцены будет вызвана функция Update
				Должна выполнять обновления объекта которые зависят от состояний других объектов игры которые могу изменяться во время прохода Update
			*/
			virtual void PostUpdate(Drawer& drawer);

			/*
				Функция отрисовки - вызывается каждый шаг один раз после того как у всех объектов графа сцены будет вызвана функция PostUpdate
				Должна выполнять отрисовку объекта с помощью DX12
			*/
			virtual void Draw(Drawer& drawer);

			/*
				Восстановление начального состояния объекта для дальнейшего переиспользования движком
			*/
			virtual void Revive();

			//Получение состояния активности объекта
			bool IsActive();

			//Получение состояния существования объекта
			bool IsExists();

			//Получение состояния видимости объекта
			bool IsVisible();

			//Получение указателя на родительский объект в графе сцены
			Base* GetParentPointer();

			//Активация объекта
			void Enable();

			//Деактивация объекта
			void Disable();

			//Скрытие объкта
			void Hide();

			//Раскрытие объекта
			void Show();

			/*
				Убийство объекта
				Указывает игрвому движку, что объект может быть переиспользован
			*/
			void Kill();

			/*
				Назначение родительского объекта в графе сцены
				Base* parent - указатель на оъект графа сцены, чтобы установить его как родителя для этого объекта сцены
			*/
			void SetParent(Base* parentPointer);
		};
	}
}